regal <- function(X, y, MaxIter=1000, d="default", NCores=1, plotBest=6,
                  verboseQ=FALSE) {
  normalize <- TRUE #assume this for now
  stopifnot(nrow(X)==length(y))
  if (identical(d, "default")) {
    d <- ceiling(length(y)/10)
  }
  kMax <- 29-3
  k <- 0
  #methods that require p < n
  if (ncol(X) < length(y)) {
    kMax <- kMax+3
    startTime <- proc.time()[3]
    EPE_lm <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores)
    totTime <- proc.time()[3]-startTime
    EPE_lm <- cbind(EPE_lm, cpu=totTime)
    k <- k+1
    if (verboseQ) message(paste("completed: EPE_lm", k, "of ", kMax))
    EPE_step_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                        yhat=yhat_step, ic="AIC")
    totTime <- proc.time()[3]-startTime
    EPE_step_AIC <- cbind(EPE_step_AIC, cpu=totTime)
    k <- k+1
    if(verboseQ) message(paste("completed: EPE_step_AIC", k, "of ", kMax))
    startTime <- proc.time()[3]
    EPE_step_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                        yhat=yhat_step, ic="BIC")
    totTime <- proc.time()[3]-startTime
    EPE_step_BIC <- cbind(EPE_step_BIC, cpu=totTime)
    k <- k+1
    if(verboseQ) message(paste("completed: EPE_step_BIC", k, "of ", kMax))
  }
  #pls package
  startTime <- proc.time()[3]
  EPE_PCR_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_PCR,
                     ic="AIC", libs="pls")
  totTime <- proc.time()[3]-startTime
  EPE_PCR_AIC <- cbind(EPE_PCR_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_PCR_AIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_PCR_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_PCR,
                     ic="BIC", libs="pls")
  totTime <- proc.time()[3]-startTime
  EPE_PCR_BIC <- cbind(EPE_PCR_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_PCR_BIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_PLSR_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_PCR,
                      ic="AIC", alg="PLSR", libs="pls")
  totTime <- proc.time()[3]-startTime
  EPE_PLSR_AIC <- cbind(EPE_PLSR_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_PLSR_AIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_PLSR_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_PCR,
                      ic="BIC", alg="PLSR", libs="pls")
  totTime <- proc.time()[3]-startTime
  EPE_PLSR_BIC <- c( EPE_PLSR_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_PLSR_BIC", k, "of ", kMax))
  #lars package
  startTime <- proc.time()[3]
  EPE_lars <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_lars)
  totTime <- proc.time()[3]-startTime
  EPE_lars <- cbind(EPE_lars, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_lars", k, "of ", kMax))
  #plus package
  startTime <- proc.time()[3]
  EPE_scad_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                      yhat=yhat_plus, normalize=normalize, ic="BIC", method="scad")
  totTime <- proc.time()[3]-startTime
  EPE_scad_BIC <- cbind(EPE_scad_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_scad_BIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_scad_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                      yhat=yhat_plus, normalize=normalize, ic="AIC", method="scad")
  totTime <- proc.time()[3]-startTime
  EPE_scad_AIC <- cbind(EPE_scad_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_scad_AIC", k, "of ", kMax))
  EPE_mcp_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_plus,
                     normalize=normalize, ic="BIC", method="mc+")
  totTime <- proc.time()[3]-startTime
  EPE_mcp_BIC <- cbind(EPE_mcp_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_mcp_BIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_mcp_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_plus,
                     normalize=normalize, ic="AIC", method="mc+")
  totTime <- proc.time()[3]-startTime
  EPE_mcp_AIC <- cbind(EPE_mcp_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_mcp_AIC", k, "of ", kMax))
  #glmnet package
  startTime <- proc.time()[3]
  EPE_gel_LASSO_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                           yhat=yhat_gel, alpha=1, ic="BIC")
  totTime <- proc.time()[3]-startTime
  EPE_gel_LASSO_BIC <- cbind(EPE_gel_LASSO_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_gel_LASSO_BIC", k, "of ", kMax))
  EPE_gel_LASSO_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                           yhat=yhat_gel, alpha=1, ic="AIC")
  totTime <- proc.time()[3]-startTime
  EPE_gel_LASSO_AIC <- cbind(EPE_gel_LASSO_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_gel_LASSO_AIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_gel_RR_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                        yhat=yhat_gel, alpha=0.025, ic="BIC")
  totTime <- proc.time()[3]-startTime
  EPE_gel_RR_BIC <- cbind(EPE_gel_RR_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_gel_RR_BIC", k, "of ", kMax))
  EPE_gel_RR_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                        yhat=yhat_gel, alpha=0.025, ic="AIC")
  totTime <- proc.time()[3]-startTime
  EPE_gel_RR_AIC <- cbind(EPE_gel_RR_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_gel_RR_AIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_gel_ELH_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                         yhat=yhat_gel, alpha=0.5, ic="BIC")
  totTime <- proc.time()[3]-startTime
  EPE_gel_ELH_BIC <- cbind(EPE_gel_ELH_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_gel_ELH_BIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_gel_ELH_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                         yhat=yhat_gel, alpha=0.5, ic="AIC")
  totTime <- proc.time()[3]-startTime
  EPE_gel_ELH_AIC <- cbind(EPE_gel_ELH_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_gel_ELH_AIC", k, "of ", kMax))
  #grpreg package
  startTime <- proc.time()[3]
  EPE_reg_LASSO_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                           yhat=yhat_reg, penalty="lasso", ic="BIC", libs="grpreg")
  totTime <- proc.time()[3]-startTime
  EPE_reg_LASSO_BIC <- cbind(EPE_reg_LASSO_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_reg_LASSO_BIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_reg_LASSO_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                           yhat=yhat_reg, penalty="lasso", ic="AIC", libs="grpreg")
  totTime <- proc.time()[3]-startTime
  EPE_reg_LASSO_AIC <- cbind(EPE_reg_LASSO_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_reg_LASSO_AIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_reg_RR_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                        yhat=yhat_reg, penalty="ridge", ic="BIC", libs="grpreg")
  totTime <- proc.time()[3]-startTime
  EPE_reg_RR_BIC <- cbind(EPE_reg_RR_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_reg_RR_BIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_reg_RR_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                        yhat=yhat_reg, penalty="ridge", ic="AIC", libs="grpreg")
  totTime <- proc.time()[3]-startTime
  EPE_reg_RR_AIC <- cbind(EPE_reg_RR_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_reg_RR_AIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_reg_scad_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                          yhat=yhat_reg, penalty="scad", ic="BIC", libs="grpreg")
  totTime <- proc.time()[3]-startTime
  EPE_reg_scad_BIC <- cbind(EPE_reg_scad_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_reg_scad_BIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_reg_scad_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                          yhat=yhat_reg, penalty="scad", ic="AIC", libs="grpreg")
  totTime <- proc.time()[3]-startTime
  EPE_reg_scad_AIC <- cbind(EPE_reg_scad_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_reg_scad_AIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_reg_mcp_BIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                         yhat=yhat_reg, penalty="mcp", ic="BIC", libs="grpreg")
  totTime <- proc.time()[3]-startTime
  EPE_reg_mcp_BIC <- cbind(EPE_reg_mcp_BIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_reg_mcp_BIC", k, "of ", kMax))
  startTime <- proc.time()[3]
  EPE_reg_mcp_AIC <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores,
                         yhat=yhat_reg, penalty="mcp", ic="AIC", libs="grpreg")
  totTime <- proc.time()[3]-startTime
  EPE_reg_mcp_AIC <- cbind(EPE_reg_mcp_AIC, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_reg_mcp_AIC", k, "of ", kMax))
  #randomForest
  startTime <- proc.time()[3]
  EPE_RF <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_RF,
                libs="randomForest")
  totTime <- proc.time()[3]-startTime
  EPE_RF <- cbind(EPE_RF, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_RF", k, "of ", kMax))
  #e1071 for svm()
  startTime <- proc.time()[3]
  EPE_SVM <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_SVM,
                 libs="e1071")
  totTime <- proc.time()[3]-startTime
  EPE_SVM <- cbind(EPE_SVM, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_SVM", k, "of ", kMax))
  #nearest neighbor
  startTime <- proc.time()[3]
  EPE_nn <- gcv(X, y, MaxIter=MaxIter, d=d, NCores=NCores, yhat=yhat_nn,
                normalize=normalize)
  totTime <- proc.time()[3]-startTime
  EPE_nn <- cbind(EPE_nn, cpu=totTime)
  k <- k+1
  if(verboseQ) message(paste("completed: EPE_nn", k, "of ", kMax))
  #
  m <- rbind(pcrAIC = EPE_PCR_AIC, pcrBIC = EPE_PCR_BIC,
             plsrAIC = EPE_PLSR_AIC, pcrBIC = EPE_PLSR_BIC,
             stepAIC = EPE_step_AIC, stepBIC = EPE_step_BIC,
             LASSO = EPE_lars,
             scadBIC = EPE_mcp_BIC, scadAIC = EPE_mcp_AIC,
             mcpBIC = EPE_mcp_BIC, mcpAIC = EPE_mcp_AIC,
             LASSOgelBIC = EPE_gel_LASSO_BIC,
             LASSOgelAIC = EPE_gel_LASSO_AIC,
             RRgelBIC = EPE_gel_RR_BIC,
             RRgelAIC = EPE_gel_RR_AIC,
             ELHgelBIC = EPE_gel_ELH_BIC,
             ELHgelBIC = EPE_gel_ELH_AIC,
             RLASSOBIC = EPE_reg_LASSO_BIC,
             RLASSOAIC = EPE_reg_LASSO_AIC,
             RRRBIC = EPE_reg_RR_BIC,
             RRRAIC = EPE_reg_RR_AIC,
             RSCADBIC = EPE_reg_scad_BIC,
             RSCADAIC = EPE_reg_scad_AIC,
             RMCPBIC = EPE_reg_mcp_BIC,
             RMCPAIC = EPE_reg_mcp_AIC,
             SVM = EPE_SVM, RF = EPE_RF, nn = EPE_nn, lm = EPE_lm)
  dimnames(m)[1] <- list(
    c("PCR/AIC", "PCR/BIC", "PLSR/AIC", "PLSR/BIC",
      "stepAIC", "stepBIC", "LASSO(Cp)",
      "scadBIC", "scadAIC", "mcpBIC", "mcpAIC",
      "LASSO(el,BIC)", "LASSO(el,AIC)",
      "RR(el,BIC)", "RR(el,AIC)",
      "ELH(BIC)", "ELH(AIC)",
      "RLASSOBIC", "RLASSOAIC",
      "RRRBIC", "RRRAIC",
      "RSCADBIC", "RSCADAIC",
      "RMCPBIC", "RMCPAIC",
      "SVM", "RF", "nn", "lm"))
  ind <- order(m[,1])
  m <- m[ind,]
  m <- cbind(m, rank=1:nrow(m))
  m[,2] <- 1.96*m[,2]
  dimnames(m)[[2]][2] <- "95%MOE"
  if (plotBest > 0) {
    dotchart(m[,1][1:plotBest], pch=19, cex=1.5, bg=rgb(1,1,0,0.4),
             color="blue",
             main=paste("Best", plotBest, "Predictors"))
  }
  m
}
