yhat_PCR <-
function(dfTrain, dfTest, ncomp="default", scaleQ=TRUE,
                        ic=c("BIC","AIC"), alg=c("PCR", "PLSR")) {
  ic <- match.arg(ic)
  alg <- match.arg(alg)
  if (!is.numeric(ncomp)) {
    ncomp <- ncol(dfTrain)-1 #assume n>p
  }
  if (identical(alg, "PCR")) {
    fitfun <- pls::pcr
  } else {
    fitfun <- pls::plsr
  }
  ans <- fitfun(y ~ .,  data = dfTrain, ncomp=ncomp , scale=scaleQ)
  res<-resid(ans)[,1,]
  ntr <- nrow(dfTrain)
  LL <- apply(res, MARGIN=2, FUN=function(x) -(ntr/2)*log(sum(x^2)/ntr))
  k <- ifelse(identical(ic, "AIC"), 2, log(ntr))
  iIC <- which.min(-2*LL + k*(1:ncomp))
  ansIC <- fitfun(y~., data=dfTrain, ncomp=iIC)
  pls:::predict.mvr(ansIC, dfTest)[1:nrow(dfTest),1,iIC]
}
