yhat_gel <- function(dfTrain, dfTest, alpha=1, ic=c("BIC","AIC")) {
#Gaussian, elastic net
  ic <- match.arg(ic)
  n <- nrow(dfTrain)
  n <- nrow(dfTrain)
  Xtr <- as.matrix.data.frame(dfTrain) #assumes Gaussian!
  Xte <- as.matrix.data.frame(dfTest)
  p <- ncol(Xtr)-1
  ytr <- Xtr[, p+1]
  Xtr <- Xtr[,-(p+1)]
  Xte <- Xte[,-(p+1)]
  k <- ifelse(identical(ic, "BIC"), log(n), 2)
  ans <- glmnet(Xtr, ytr, alpha=alpha)
  dev <- (1-ans$dev.ratio)*(ans$nulldev)
  ICs <- dev + k*(ans$df)
  best <- which.min(ICs)
  lambdaOpt <- ans$lambda[which.min(ICs)]
  as.vector(predict(ans, newx=Xte, s=lambdaOpt))
}
