yhat_reg <- function(dfTrain, dfTest, ic=c("BIC","AIC"),
                          penalty = c("lasso", "ridge", "mcp", "scad")) {
  ic <- match.arg(ic)
  penalty <- match.arg(penalty)
  if (identical(penalty, "ridge")) {
    penalty2 <- "grLasso"
    alpha <- 0.025
  } else {
    alpha <- 1
    penalty2 <- switch(penalty,
                       lasso = "grLasso",
                       mcp = "grMCP",
                       scad = "grSCAD")
  }
  ic <- "AIC"
  n <- nrow(dfTrain)
  Xtr <- as.matrix.data.frame(dfTrain) #assumes Gaussian!
  Xte <- as.matrix.data.frame(dfTest)
  p <- ncol(Xtr)-1
  ytr <- Xtr[, p+1]
  Xtr <- Xtr[,-(p+1)]
  Xte <- Xte[,-(p+1)]
  ans <- grpreg::grpreg(Xtr, ytr, alpha=alpha, group=rep(1, p), penalty=penalty2)
  lambdaOpt <- grpreg::select(ans, ic)$lambda
  predict(ans, X=Xte, type="response", lambda=lambdaOpt)
}
