\name{ShaoReg}
\alias{ShaoReg}
\title{Synthetic Regression Data}
\description{
Simulated multiple linear regression data from a model used in simulation experiments
reported in Shao's famous paper on cross-validation for model selection.
}
\usage{
ShaoReg(n = 20, beta = c(3, 1.5, 0, 0, 2, 0, 0, 0), rho = 0.5, sig = 1)
}
\arguments{
  \item{n}{sample size}
  \item{beta}{regression coefficients}
  \item{rho}{cross-covariance function between inputs}
  \item{sig}{residual standard deviation}
}

\details{
tba
}

\value{Data frame with n rows and p+1 columns.
The first p columns are labelled x1, ..., xp and the last column is y.
}


\references{
    Linear Model Selection by Cross-validation
    Jun Shao
    Journal of the American Statistical Association
    Vol. 88, Iss. 422, 1993
}

\author{
A. I. McLeod
}


\examples{
ShaoReg()
}

\keyword{ models }
\keyword{ regression }


