\name{logloss}
\alias{logloss}

\title{
log-loss function for multiclass prediction
}
\description{
Cross entropy or logloss is computed.
}
\usage{
logloss(y, pr)
}

\arguments{
  \item{y}{
matrix n-by-K representing the test cases using indicator variables.
}
  \item{pr}{
prediction probabilities for each row in y.
}
}
\details{
We assume that there are n test samples.
}
\value{
the log-loss
}

\references{
Log loss is used in Kaggle competitions.
}
\author{
A. I. McLeod
}

\seealso{
\code{\link{misclassificationrate}}
}

\examples{
pr1 <- c(0.8, 0.2)
pr2 <- c(0.6, 0.4)
pr <- rbind(pr1, pr2)
y1 <- c(1, 0)
y2 <- c(1, 0)
y <- rbind(y1, y2)
logloss(y, pr)
}
