\name{yhat_reg}
\alias{yhat_reg}

\title{Penalized Regression Prediction with Grpreg}

\description{
Fits penalized regression with SCAD or MCP penalty
 and computes the predictions for the test data.
}

\usage{
yhat_reg(dfTrain, dfTest, ic = c("BIC", "AIC"), 
		penalty = c("lasso", "ridge", "mcp", "scad"))
}

\arguments{
  \item{dfTrain}{Data frame for training data. Last column must be the output 
  		variable.}
  \item{dfTest}{Data frame for test data. Last column must be the output 
  		variable.}
  \item{ic}{"AIC" or "BIC"}
  \item{penalty}{"lasso", "ridge", "mcp", "scad"}
}

\value{The predictions for the test sample}

\author{A. I. McLeod}

\examples{
Xy <- prostate
X <- prostate[,-9]
y <- prostate[,9]
n <- length(y)
d <- 10
set.seed(777513)
iTe <- sample(n, size=d)
iTr <- (1:n)[!match(1:n, iTe, nomatch = 0) > 0]
trdf <- data.frame(X[iTr,], y=y[iTr]) #X, y already defined
tedf <- data.frame(X[iTe,], y=y[iTe])
yhat_reg(trdf, tedf)
}

\keyword{ models }
\keyword{ regression }

































